"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DataList = void 0;
var Data_1 = require("./Data.js");
var assert_1 = require("./utils/assert.js");
var roDescr_1 = require("./utils/roDescr.js");
var DataList = /** @class */ (function () {
    function DataList(list) {
        (0, assert_1.assert)(Array.isArray(list) &&
            list.every(Data_1.isData), "invalid list passed to constructor");
        Object.defineProperties(this, {
            list: __assign({ value: list }, roDescr_1.roDescr)
        });
    }
    DataList.prototype.clone = function () {
        return new DataList(this.list.map(function (dataElem) { return dataElem.clone(); }));
    };
    DataList.prototype.toJson = function () {
        return {
            list: this.list.map(function (elem) { return elem.toJson(); })
        };
    };
    DataList.prototype.toString = function () {
        return "List [".concat(this.list.map(function (data) { return data.toString(); }).join(","), "]");
    };
    return DataList;
}());
exports.DataList = DataList;
